﻿using System.Collections.Generic;
using System;
using Import_Excel_Core_MVC.Models;
using Microsoft.AspNetCore.Mvc;
using System.IO;
using System.Data;
using System.Linq;
using ClosedXML.Excel;
using Microsoft.AspNetCore.Http;

namespace Import_Excel_Core_MVC.Controllers
{
    public class HomeController : Controller
    {
        public IActionResult Index()
        {
            return View();
        }

        [HttpPost]
        public IActionResult Index(IFormFile posteFile)
        {
            DataTable dt = new DataTable();
            using (MemoryStream stream = new MemoryStream())
            {
                posteFile.CopyTo(stream);
                using (XLWorkbook workBook = new XLWorkbook(stream))
                {
                    IXLWorksheet workSheet = workBook.Worksheet(1);
                    bool firstRow = true;
                    foreach (IXLRow row in workSheet.Rows())
                    {
                        if (firstRow)
                        {
                            foreach (IXLCell cell in row.Cells())
                            {
                                dt.Columns.Add(cell.Value.ToString());
                            }
                            firstRow = false;
                        }
                        else
                        {
                            dt.Rows.Add();
                            int i = 0;
                            foreach (IXLCell cell in row.Cells())
                            {
                                dt.Rows[dt.Rows.Count - 1][i] = cell.Value.ToString();
                                i++;
                            }
                        }
                    }
                }
            }

            List<Customer> customers = (from DataRow dr in dt.Rows
                                        select new Customer()
                                        {
                                            CustomerId = Convert.ToInt32(dr["Id"]),
                                            Name = dr["Name"].ToString(),
                                            Country = dr["Country"].ToString()
                                        }).ToList();

            return View(customers);
        }
    }
}